<%@page import="java.util.*,                
                java.text.*,
                blackboard.data.*,                
                blackboard.base.*,
                blackboard.data.user.*,
                blackboard.platform.*,
                blackboard.platform.log.*,
                blackboard.platform.security.*,
                blackboard.platform.session.*,
                blackboard.platform.persistence.*,
                blackboard.platform.plugin.*,
                blackboard.platform.db.*,
                java.io.*,
                java.net.URLEncoder.*,
                com.atlassys.products.ares.webservice.*"
%>

<%@ taglib uri="/bbData" prefix="bb" %>
<%@ taglib uri="/bbNG" prefix="bbNG" %>
<%@ include file="/WEB-INF/library/include.jspf" %>

<%!
    
    private String isSelected(String compareValue, String Value)
    {
        if (Value.equalsIgnoreCase(compareValue))
        {
            return " selected=\"selected\"";
        }
        else
        {
            return "";
        }
    }

  private void SaveProperties(PlugInConfig pic) throws IOException
  {
    // Stream to write file
    FileOutputStream fout;		
    try
    {
        // Open an output stream
	fout = new FileOutputStream(pic.getConfigDirectory() + "/aresBB.settings");
        // Print a line of text
        new PrintStream(fout).println ("loginURL=" + loginURLText);
        new PrintStream(fout).println ("wsURL=" + wsURLText);
        new PrintStream(fout).println ("verboseError=" + verboseErrorValue);
        new PrintStream(fout).println ("studentPageTitle=" + studentPageTitleText);
        new PrintStream(fout).println ("instructorPageTitle=" + instructorPageTitleText);
        new PrintStream(fout).println ("instructorAddItemsText=" + aresInstructorTextAddItems);
        new PrintStream(fout).println ("studentViewCourseText=" + aresStudentTextViewCoursePage);
        new PrintStream(fout).println ("semesterOption=" + semesterOptionValue);        

        // Close our output stream
        fout.close();		
    }
    // Catches any error conditions
    catch (IOException e)
    {
            System.err.println ("Unable to write to file");
            System.exit(-1);
    }
  }
%>

<bbNG:breadcrumbBar navItem="admin_plugin_manage">
  <bbNG:breadcrumb>Ares Course Reserves</bbNG:breadcrumb>
</bbNG:breadcrumbBar>

<bbNG:genericPage>

	<bbNG:pageHeader>
		<bbNG:pageTitleBar title="Ares Course Reserves Configuration"></bbNG:pageTitleBar>
	</bbNG:pageHeader>

	<%
		//String action = getParameterOrEmptyString(request,"action").trim();

		PlugInConfig pic = new PlugInConfig(PLUGIN_VID, PLUGIN_HANDLE );  
	  
		loginURLText = getParameterOrEmptyString(request, "loginURL").trim();
		wsURLText = getParameterOrEmptyString(request, "wsURL").trim();    
		semesterOptionValue = getParameterOrEmptyString(request, "semesterOption").trim();
		verboseErrorValue = getParameterOrEmptyString(request, "verboseError").trim();
		studentPageTitleText = getParameterOrEmptyString(request, "studentPageTitleText").trim();
		instructorPageTitleText = getParameterOrEmptyString(request, "instructorPageTitleText").trim();
		aresInstructorTextAddItems = getParameterOrEmptyString(request, "aresInstructorTextAddItems").trim();        
		aresStudentTextViewCoursePage = getParameterOrEmptyString(request, "aresStudentTextViewCoursePage").trim();        
		


		String loginURLError = null;
		String wsURLError = null;
		String semesterOptionDisplayOptionError = null;
		String verboseErrorOptionError = null;    
		String instructorPageTitleError = null;
		String aresInstructorAddItemsError = null;
		String studentPageTitleError = null;
		String aresStudentViewCoursePageError = null;   

		boolean hideForm = false;

		if( request.getParameter("update") != null) 
		{
			int errorCount = 0;

			if (! loginURLText.matches("^([hH][tT][tT][pP][sS]?://[-a-zA-Z0-9._]+(|:\\d{1,5}))(/.*?)")) {
			  loginURLError = "<div class=\"required\">URL must start http:// or https://, followed by a hostname,  optionally followed by a colon and a port number</div>";
			  errorCount++;
			} else {
			  // If a trailing slash is present, remove it
			  loginURLText = loginURLText.replaceFirst("/$", "");
			}
			
			if (! wsURLText.matches("^([hH][tT][tT][pP][sS]?://[-a-zA-Z0-9._]+(|:\\d{1,5}))(/.*?)")) {
			  wsURLError = "<div class=\"required\">URL must start http:// or https://, followed by a hostname,  optionally followed by a colon and a port number</div>";
			  errorCount++;
			} else {
			  // If a trailing slash is present, remove it
			  wsURLText = wsURLText.replaceFirst("/$", "");
			}

			if (! studentPageTitleText.matches(".+")) {
			  studentPageTitleError = "<div class=\"required\">Please enter a Header for the Student Page</div>";
			  errorCount++;
			}

			if (! instructorPageTitleText.matches(".+")) {
			  instructorPageTitleError = "<div class=\"required\">Please enter a Header for the Instructor Page</div>";
			  errorCount++;
			}

			if (! aresInstructorTextAddItems.matches(".+")) {
			  aresInstructorAddItemsError = "<div class=\"required\">Please enter the text for Instructor's Add Item link</div>";
			  errorCount++;
			}

			if (! aresStudentTextViewCoursePage.matches(".+")) {
			  aresStudentViewCoursePageError = "<div class=\"required\">Please enter the text for Student's View Course link</div>";
			  errorCount++;
			}

			if (errorCount == 0) 
			{      
				try {            
					SaveProperties(pic);
				}
				catch (Exception ex)
				{
				  %>
				  <bbNG:receipt type="FAILURE" iconUrl="/images/ci/icons/tools_u.gif" title="Configure Ares Building Block">
					   <%= ex.getMessage() %>
					  <span style="color: red;">Unable to save properties at this time<br/>              
				  </bbNG:receipt>          
				  <%                 
				}
				
				try 
				{
				
					//com.atlassys.products.ares.webservice.AresWebService impl = new com.atlassys.products.ares.webservice.AresWebService();        
					//com.atlassys.products.ares.webservice.AresWebServiceSoap port =  impl.getAresWebServiceSoap(wsURLText);// com.atlassys.products.ares.webservice.AresWebService() (com.atlassys.products.ares.webservice.AresWebServiceSoap_Stub)impl.getAresWebServiceSoap();
							   
					com.atlassys.products.ares.webservice.AresWebServiceLocator locator = new com.atlassys.products.ares.webservice.AresWebServiceLocator();
					com.atlassys.products.ares.webservice.AresWebServiceSoapStub port = (com.atlassys.products.ares.webservice.AresWebServiceSoapStub) locator.getAresWebServiceSoap();
					
					port._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, wsURLText);
				
					// TODO process result here
					java.lang.String returnedUserAgent = port.getUserAgent();
					%>
						<bbNG:receipt type="SUCCESS" iconUrl="/images/ci/icons/tools_u.gif" title="Configure Ares Building Block">
							Ares Configuration Saved.<br/>Connected to the Ares Web Service successfully using HTTP User Agent: <%= returnedUserAgent %>
						</bbNG:receipt> 	
					<%                 

					hideForm = true;
				} 
				catch (Exception ex) 
				{
					%>
						<bbNG:receipt type="FAILURE" iconUrl="/images/ci/icons/tools_u.gif" title="Configure Ares Building Block">
							<%= ex.getMessage() %>                 
							<span style="color: red;">The WebService URL appears to be incorrect. Blackboard was unable to connect to <%= wsURLText %><br/>
							Please verify the address with your campus Ares administrator.</span>
						</bbNG:receipt> 
					<%                 
				}
			}
		} 
		else 
		{
			try
			{        
				LoadProperties(pic);
			}
			catch(Exception e)
			{
				out.print("<br>" + e.getMessage() + "</br>");
			}
		}

		if(!hideForm)
		{
			%>
				<FORM ACTION="aresSetup.jsp" METHOD="POST">
					<input type="hidden" name="update" value="1" />
					<bbNG:dataCollection>
						<bbNG:stepGroup title="Ares Building Block Configuration">
							<bbNG:step title="Ares Server Information">
								<!-- Ares main DLL URL --> 
								<% 
								if (loginURLError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= loginURLError %></bbNG:dataElement>
								<%
								} 
								%>        
								<bbNG:dataElement label="Web Login URL"><input type="text" name="loginURL" size="100" value="<%= HTMLEncode(loginURLText) %>" /></bbNG:dataElement>
								
								<!-- Web Service URL -->
								<% 
								if (wsURLError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= wsURLError %></bbNG:dataElement>
								<%
								} 
								%>       
								<bbNG:dataElement label="Web Service URL"><input type="text" name="wsURL" size="100" value="<%= HTMLEncode(wsURLText) %>" /></bbNG:dataElement>
								
								<!-- Verbose Errors For Debugging Purposes -->
								<% 
								if (verboseErrorOptionError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= verboseErrorOptionError %></bbNG:dataElement>
								<%
								} 
								%>       
								<bbNG:dataElement label="Verbose Logging">
									<select name="verboseError">
										<option value="0"<%= isSelected("0",verboseErrorValue) %>>No Logging</option>
										<option value="1"<%= isSelected("1",verboseErrorValue) %>>Yes, for errors</option>
										<option value="2"<%= isSelected("2",verboseErrorValue) %>>Yes, to display information being retrieved from Blackboard.</option>
									</select>            
								</bbNG:dataElement>        
							</bbNG:step>        
							<bbNG:step title="Blackboard Ares Web Page Customizations">

                                                                <!-- Instructor Display and Student Display options removed since Direct Links was not working. Only Class Links will be displayed. -->

								<!-- Instructor Page Title/Header -->
								<% 
								if (instructorPageTitleError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= instructorPageTitleError %></bbNG:dataElement>
								<%
								} 
								%>        
								<bbNG:dataElement label="Instructor Page Header"><input type="text" name="instructorPageTitleText" size="100" value="<%= HTMLEncode(instructorPageTitleText) %>" /></bbNG:dataElement>

								<!-- Instructor Add Items Link -->
								<% 
								if (aresInstructorAddItemsError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= aresInstructorAddItemsError %></bbNG:dataElement>
								<%
								} 
								%>        
								<bbNG:dataElement label="Instructor Add Items Link"><input type="text" name="aresInstructorTextAddItems" size="100" value="<%= HTMLEncode(aresInstructorTextAddItems) %>" /></bbNG:dataElement>

								<!-- Student Page Title/Header -->
								<% 
								if (studentPageTitleError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= studentPageTitleError %></bbNG:dataElement>
								<%
								} 
								%>        
								<bbNG:dataElement label="Student Page Header"><input type="text" name="studentPageTitleText" size="100" value="<%= HTMLEncode(studentPageTitleText) %>" /></bbNG:dataElement>
								
								<!-- Student View  Link -->
								<% 
								if (aresStudentViewCoursePageError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= aresStudentViewCoursePageError %></bbNG:dataElement>
								<%
								} 
								%>        
								<bbNG:dataElement label="Student View Course Link"><input type="text" name="aresStudentTextViewCoursePage" size="100" value="<%= HTMLEncode(aresStudentTextViewCoursePage) %>" /></bbNG:dataElement>
								
								 <!-- Semester Option -->
								<% 
								if (semesterOptionDisplayOptionError != null) 
								{ 
								%>
								<bbNG:dataElement label=""><%= semesterOptionDisplayOptionError %></bbNG:dataElement>
								<%
								} 
								%>       
								<bbNG:dataElement label="Ares Course Semester">
									<select name="semesterOption">
										<option value="1"<%= isSelected("1",semesterOptionValue) %>>Blackboard Course Dates / Current Ares Semester
										<option value="2"<%= isSelected("2",semesterOptionValue) %>>Instructor Chooses Semester
									</select>            
								</bbNG:dataElement>        
								
							</bbNG:step>
							
							<bbNG:stepSubmit title="Submit" />
						</bbNG:stepGroup>
					</bbNG:dataCollection>
				</form>
			<%
		}
	%>
	
</bbNG:genericPage>