<%@page import="java.net.*,
                java.util.*,
                blackboard.platform.*,
                blackboard.persist.*,
                blackboard.data.user.*,
                blackboard.persist.user.*,
                blackboard.data.course.*,
                blackboard.persist.course.*,
                javax.xml.datatype.DatatypeFactory,
                com.atlassys.products.ares.webservice.*
                "%>  
<%@ taglib uri="/bbData" prefix="bbData" %>
<%@ taglib uri="/bbNG" prefix="bbNG"%>

<%@ include file="/WEB-INF/library/include.jspf" %>

<%
    PlugInConfig pic = new PlugInConfig(PLUGIN_VID, PLUGIN_HANDLE );                 
    LoadProperties(pic);    
%>
<bbNG:learningSystemPage ctxId="ctx">
<%
         
    com.atlassys.products.ares.webservice.AresWebServiceLocator locator = new com.atlassys.products.ares.webservice.AresWebServiceLocator();
    com.atlassys.products.ares.webservice.AresWebServiceSoapStub port = (com.atlassys.products.ares.webservice.AresWebServiceSoapStub) locator.getAresWebServiceSoap();
        
    port._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, wsURLText);    

    //Retrieve the Db persistence manager from the persistence service
    BbPersistenceManager bbPm =
    BbServiceManager.getPersistenceService().getDbPersistenceManager();
       
    //Get the Current Course
    
    Course sessionCourse = CourseDbLoader.Default.getInstance().loadByBatchUid(request.getParameter("cbuid"));
    final Integer INVALID_SEMESTER_RESULT = -1; // This exists in view.jsp, include.jspf, and manualsemester.jsp

    java.lang.String bbUniqueCourseId = sessionCourse.getBatchUid();
    java.lang.String outputDisplay = "";
    java.lang.String redirectURL = "";
    java.lang.String aresUserName = "";        
    java.lang.Boolean aresUserExists = false;
    java.lang.Boolean hasValidSemesters = false;
    
    String DATE_FORMAT_NOW = "yyyy-MM-dd";
    SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
         
    java.lang.Integer aresClassId = 0;
    
    User user = blackboard.persist.user.UserDbLoader.Default.getInstance().loadByBatchUid(request.getParameter("ubuid"));
    
    // get the membership data to determine the User's Role
    CourseMembership crsMembership = null;
    CourseMembershipDbLoader crsMembershipLoader = null;

    crsMembershipLoader = (CourseMembershipDbLoader) bbPm.getLoader(CourseMembershipDbLoader.TYPE);
    try
    {
        crsMembership = crsMembershipLoader.loadByCourseAndUserId(sessionCourse.getId(), user.getId());

        //response.sendRedirect(redirectURL);

        try 
        {
            aresUserName = port.retrieveUsernameForExternalUserId(user.getBatchUid());
            
            aresUserExists = (aresUserName != "");
            
            if (aresUserExists == false)
            {
                if (port.userExists(user.getBatchUid()))
                {
                    aresUserName = user.getBatchUid();
                    aresUserExists = true;
                }
            }
              
            if (aresUserExists == false)
            { 
                redirectURL = "view.jsp";
            }
            
            blackboard.data.course.CourseMembership.Role currentRole = crsMembership.getRole();
            
            bbUniqueCourseId = sessionCourse.getBatchUid();

            if(request.getParameter("aresclassid").equals(Integer.toString(INVALID_SEMESTER_RESULT)))
            {
                aresClassId = Integer.parseInt(request.getParameter("aresclassid"));
            }
            else
            {
                MyCourse result = port.getCourseByExternalId(bbUniqueCourseId);
                aresClassId = result.getClassId();
            }

            //Check to see if the Ares Class ID was created in the last step, or if it was sent as no valid semester...
            if ((aresClassId > 0) || (aresClassId == INVALID_SEMESTER_RESULT))
            {         
                ClassUserType currentType = port.retrieveCourseMembershipType(aresClassId, aresUserName);
                
                if ((currentRole == CourseMembership.Role.INSTRUCTOR) ||
                   (currentRole == CourseMembership.Role.COURSE_BUILDER) ||
                   (currentRole == CourseMembership.Role.TEACHING_ASSISTANT))
                {
                    if((request.getParameter("aresclassid") != null) && (aresClassId != INVALID_SEMESTER_RESULT))
                    {      
                        MySemester chosenSemester = port.getSemesterInfo(request.getParameter("csem"));
                        
                        port.updateCourse(aresClassId, "Semester", request.getParameter("csem"));    
                        port.updateCourse(aresClassId, "StartDate", sdf.format(chosenSemester.getStartDate().getTime()));
                        port.updateCourse(aresClassId, "StopDate", sdf.format(chosenSemester.getEndDate().getTime()));
                        
                        redirectURL = "view.jsp";
                    }
                    else
                    {
                        MySemester[] semesterList = port.getSemesters();                                                                      
                        Integer i = 0;
                        
                        Calendar now = Calendar.getInstance();
                        
                        for ( i=0; i < semesterList.length; i++ ) 
                        {
                            MySemester currentSemester = semesterList[i];                            
                            if ((currentSemester.getEndDate().after(now)) && (currentSemester.getItemAdditionDate()).before(now))                            
                            {                            
                                outputDisplay += "<option>" + currentSemester.getSemesterName() + "</option>";
                                hasValidSemesters = true;
                            }
                        }
                        
                        if(!hasValidSemesters)
                        {
                            outputDisplay += "There are no valid semesters.<br/>";
                        }
                    }
                }
                else                    
                {   
                    redirectURL = "view.jsp";                
                }
            }
            else                    
            {   
                redirectURL = "view.jsp";                
            }
        }    
        catch (Exception ex)
        {
            if (ex.getMessage().startsWith("Invalid UserAgent:"))
            {
               outputDisplay = outputDisplay + "Ares Course Reserves currently does not accept connections from Blackboard.";
            }    
            else
            {
                if (verboseErrorValue.equals("1"))
                {
                    outputDisplay = outputDisplay + ex.getMessage() + "<br/>";
                }    
            } 
        }        
    }
    catch (Exception pe)
    {
        // There is no membership record.
        redirectURL = "view.jsp";
    }
    
    if (redirectURL != "")
    {            
		response.sendRedirect(redirectURL + "?cbuid=" + sessionCourse.getBatchUid() + "&ubuid=" + user.getBatchUid() + "&course_id=" + request.getParameter("course_id"));
    }
    else
    {   
%>
			<bbNG:breadcrumbBar environment="course" navItem="">
				<bbNG:breadcrumb><%=instructorPageTitleText%></bbNG:breadcrumb>
			</bbNG:breadcrumbBar>
			<bbNG:pageHeader>
				<bbNG:pageTitleBar title="<%= instructorPageTitleText %>"></bbNG:pageTitleBar>
			</bbNG:pageHeader>
                        <%
                        if(hasValidSemesters)
                        {
                        %>
			<bbNG:dataCollection>
				<bbNG:stepGroup title="Manual Semester">
					<bbNG:step title="Choose a semester for this course">
                                            <FORM ACTION="view.jsp" METHOD="POST">
						<input type="hidden" name="update" value="1" />
						<input type="hidden" name="aresclassid" value="<%= aresClassId %>" />
						<input type="hidden" name="cbuid" value="<%= request.getParameter("cbuid") %>" />
						<input type="hidden" name="ubuid" value="<%= request.getParameter("ubuid") %>" />
						<input type="hidden" name="course_id" value="<%= request.getParameter("course_id") %>" />
						
						<bbNG:dataElement label="<%= instructorPageTitleText %>">

							<select name="csem">
                                                        <%    
                                                            out.print(outputDisplay);
                                                        %>
							</select>            
                                                    
						</bbNG:dataElement>
                                                
					</bbNG:step>

                                        <bbNG:stepSubmit title="Submit" />

				</bbNG:stepGroup>
			</bbNG:dataCollection>
                        <%
                        }
                        else
                        {
                        %>
                            <span><p>The course cannot be created at this time because there are no active semesters.</p></span>
                        <%    
                        }
                        %>
<%
    }
%>
</bbNG:learningSystemPage>